var filename;
var password;
var confirm;
var cryptFunc;
var isCollapsed = true;
var resizeAnimation = {startTime:0, duration:250, positionFrom:0, positionTo:0, positionNow:0, frameFrom:0, frameTo:0, frameNow:0, timer:null, element:null, image:null, background:null, onfinished:null};

function test(event) {

}

function doCrypt(event) {
	if( cryptFunc == 'encrypt' ) {
		encrypt(event);
	} else {
		decrypt(event);
	}
}

function encryptPanel( event ) {	
	
	var uri = null;
	try {
		uri = event.dataTransfer.getData("text/uri-list");
	} 
	catch (ex) {
	}
  if (uri)
	{
		
		cryptFunc = 'encrypt';		
    togglePassPanel(event);
		filename = decodeURIComponent(uri.substr(16, 300));
	}
	
	event.stopPropagation();
	event.preventDefault();
}

function encrypt() {
	togglePassPanel(event);
	password = document.getElementById("passwordField").value;
	confirm = document.getElementById("confirmField").value;
	var regEx = new RegExp(" ", "gi");
	filename = filename.replace( regEx, "\\ " );
	if( password == '' ) {
		showError(  "A password is required to encrypt.<br />Please try again." );
	}
	if( password == confirm ) {
		var output = widget.system("/usr/bin/openssl aes-256-cbc -e -in " + filename + " -out " + filename + ".enc -pass pass:" + password, null).errorString;
		if( output ) {
			showError( output );
		} else {
			document.getElementById("passwordField").value = "";
			document.getElementById("confirmField").value = "";
			document.getElementById("error").innerText = "";
			document.getElementById("message").innerHTML = "Your file has been successfully encrypted!";
			setTimeout( "doFlip()", 600 );
		}
	} else {
		showError(  "Your passwords did not match.<br />Please try again." );
	} 
}

function decryptPanel( event ) {
	var uri = null;
	try {
		uri = event.dataTransfer.getData("text/uri-list");	
	} 
	catch (ex) {
	}
  if (uri)
	{
		
		cryptFunc = 'decrypt';		
    togglePassPanel(event);
		filename = decodeURIComponent(uri.substr(16, 300));
	}
	
	event.stopPropagation();
	event.preventDefault();
}

function decrypt() {
	togglePassPanel(event);
	password = document.getElementById("passwordField").value;
	confirm = document.getElementById("confirmField").value;
	var regEx = new RegExp(" ", "gi");
	filename = filename.replace( regEx, "\\ " );
	regEx = new RegExp(".enc", "gi");
	filename = filename.replace( regEx, "" );
	if( password == '' ) {
		showError(  "A password is required to decrypt.<br />Please try again." );
	}
	if( password == confirm ) {
				
		var output = widget.system("/usr/bin/openssl aes-256-cbc -d -in " + filename + ".enc -out " + filename + " -pass pass:" + password, null).errorString;
		if( output ) {
			showError( "Your password is incorrect<br />Please try again." );
		} else {
			document.getElementById("passwordField").value = "";
			document.getElementById("confirmField").value = "";
			document.getElementById("error").innerText = "";
			document.getElementById("message").innerHTML = "Your file has been successfully decrypted!";
			setTimeout( "doFlip()", 600 );
		}
	} else {
		showError(  "Your passwords did not match.<br />Please try again." );
	} 
}

function showError( msg ) {
	document.getElementById("passwordField").value = "";
	document.getElementById("confirmField").value = "";
	document.getElementById("error").innerText = "ERROR";
	document.getElementById("message").innerHTML = msg;
	setTimeout( "doFlip()", 600 );
	exit;
}

function showInstructions(event) {
	document.getElementById("error").innerText = "";
	document.getElementById("message").innerHTML = "Start dragging a file in the Finder, press F12 to open the Dashboard, drop your file on Ecrypt or Decrypt to process the file, enter a password, confirm, and click Submit.";
}

function dragenter (event) {
	event.stopPropagation();
	event.preventDefault();

}

function dragover (event) {
	event.stopPropagation();
	event.preventDefault();
}

function dragleave (event) {
	event.stopPropagation();
	event.preventDefault();
}

function togglePassPanel( event ) {
    var passDiv = document.getElementById( "passPanel" );
    var timeNow = (new Date).getTime();
    var startSize = parseInt(passDiv.offsetTop,10);
    
    resizeAnimation.element = passDiv;
    if (resizeAnimation.timer != null) {
        clearInterval(resizeAnimation.timer);
        resizeAnimation.timer = null;
    }
    
    resizeAnimation.duration = 400;
    
    ( startSize == 120 ) ? isCollapsed = true : isCollapsed = false;
    var resizeTo = isCollapsed ? 175 : 120;

    resizeAnimation.startTime = timeNow - 13; 
    resizeAnimation.from = startSize;
    resizeAnimation.to = resizeTo;
    resizeAnimation.timer = setInterval ("panelAnimate();", 13);
    panelAnimate();
    
    
}

function panelAnimate() {
	var T;
	var ease;
	var time = (new Date).getTime();
	
    T = limit_3(time-resizeAnimation.startTime, 0, resizeAnimation.duration);
    if (T >= resizeAnimation.duration) {
		clearInterval(resizeAnimation.timer);
		resizeAnimation.timer = null;
		resizeAnimation.now = resizeAnimation.to;
	}
	else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / resizeAnimation.duration));
		resizeAnimation.now = computeNextFloat(resizeAnimation.from, resizeAnimation.to, ease);
	}
	
	resizeAnimation.element.style.top = resizeAnimation.now;
	window.resizeTo( 350, resizeAnimation.now + 70 );
}